#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "ctype.h"

#define N 50 

int n,cnt,res_cnt;

//-1 = '#'
//0  = 'B'
//1,2,3 ... = 1,2,3 ...

int board[N][N]; //-1,0,1,2,3

int X[N*N];
int Y[N*N];

int resX[N*N];
int resY[N*N];

bool CheckCell(int x,int y,int basex,int basey);
bool CheckRepeat(int x,int y);

int main(int argc, char* argv[])
{
	int i=0;
	int j=0;
	int counter=0;
	int temp,bx,by;

	char str[5];

	cnt=0;
	

	freopen("game.in","r",stdin);
	freopen("game.out","w",stdout);

	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		scanf("\n");

		for(j=0;j<n;j++)
		{
			str[0] = '\0';
			if(j<(n-1))
			{
				scanf("%s ",&str);
			}
			else
			{
				scanf("%s",&str);
			}

			if(isdigit(str[0]))
			{
				board[i][j] = atoi(str);
				X[cnt]=i;
				Y[cnt]=j;
				cnt++;
			}
			else
			{
				if(str[0] == 'B')
				{
					board[i][j] = 0;
				}
				else //'#'
				{
					board[i][j] = -1;
				}
			}
		}
	}

	i=0;
	while(i < cnt)
	{
		bx=X[i];
		by=Y[i];
		if(CheckCell(bx,by,bx,by))
		{
			res_cnt=0;
			temp=0;
			counter = board[bx][by];

			resX[res_cnt] = bx;
			resY[res_cnt] = by;
			res_cnt++;
			counter--;
			
			if(counter == 0) break;

			while(temp < res_cnt)
			{
				if(resX[temp] > 0)
				{
					if(CheckCell(resX[temp]-1,resY[temp],bx,by)) 
					{
						resX[res_cnt] = resX[temp]-1;
						resY[res_cnt] = resY[temp];
						res_cnt++;
						counter--;
						if(counter == 0) break;	
					}				
				}
				if(resY[temp] > 0)
				{
					if(CheckCell(resX[temp],resY[temp]-1,bx,by)) 
					{
						resX[res_cnt] = resX[temp];
						resY[res_cnt] = resY[temp]-1;
						res_cnt++;
						counter--;
						if(counter == 0) break;	
					}				
				}
				if(resX[temp] < (n-1))
				{
					if(CheckCell(resX[temp]+1,resY[temp],bx,by)) 
					{
						resX[res_cnt] = resX[temp]+1;
						resY[res_cnt] = resY[temp];
						res_cnt++;
						counter--;
						if(counter == 0) break;	
					}				
				}
				if(resY[temp] < (n-1))
				{
					if(CheckCell(resX[temp],resY[temp]+1,bx,by)) 
					{
						resX[res_cnt] = resX[temp];
						resY[res_cnt] = resY[temp]+1;
						res_cnt++;
						counter--;
						if(counter == 0) break;	
					}				
				}
				temp++;
			}
			if(counter == 0) break;	
		}
		i++;
	}

	if(counter == 0)
	{
		printf("%d",res_cnt);
		for(i=0;i < res_cnt;i++)
		{
			printf("\n%d %d",resX[i],resY[i]);
		}
	}
	
	return 0;
}

bool CheckRepeat(int x,int y)
{
	for(int d=0;d < res_cnt;d++)
	{
		if(resX[d] == x)
		{
			if(resY[d] == y)
			{
				return true;
			}
		}
	}
	return false;
}

bool CheckCell(int x, int y, int basex, int basey)
{
	if((basex != x) || (basey != y))
		if(board[x][y] >= 0) return false;
	
	if(CheckRepeat(x,y)) return false;

	if(x > 0)
	{
		if((x-1) != basex)
			if(board[x-1][y] == 0) return false;	
	}
	if(y > 0)
	{			
		if((y-1) != basey)
			if(board[x][y-1] == 0) return false;
	}
	if(x < (n-1))
	{
		if((x+1) != basex)
			if(board[x+1][y] == 0) return false;	
	}
	if(y < (n-1))
	{		
		if((y+1) != basey)
			if(board[x][y+1] == 0) return false;	
	}

	return true;
}